import styled from 'styled-components';
import { Button } from "../../../inputs";
import { ButtonType } from '../../types';
export var SessionButton = styled(Button).withConfig({ displayName: "SessionButton", componentId: "sc-7whzsr" })({
    position: 'absolute',
    top: '50%',
    left: '50%',
    transform: 'translate(-50%, -50%)',
    whiteSpace: 'nowrap',
    fontSize: '14px',
    backgroundColor: 'transparent',
    borderRadius: '25px',
    transition: '0.2s backgroundColor, 0.2s color',
}, function (_a) {
    var theme = _a.theme, btnType = _a.btnType;
    var color = btnType === ButtonType.tertiary
        ? theme.colors.white.default
        : theme.colors.primary.dark;
    var backgroundColor = btnType === ButtonType.tertiary
        ? theme.colors.primary.dark
        : theme.colors.white.default;
    return {
        color: backgroundColor,
        border: "1px solid " + backgroundColor,
        '&:focus': {
            backgroundColor: backgroundColor,
            color: color,
        },
        '&:active': {
            backgroundColor: backgroundColor,
            color: color,
        },
        '&:active:hover': {
            backgroundColor: backgroundColor,
            color: color,
        },
        '&:hover': {
            backgroundColor: backgroundColor,
            color: color,
        },
    };
});
