var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var _a;
import styled, { css, keyframes } from 'styled-components';
import { DropDirection } from './constants';
var dropDirectionMap = (_a = {},
    _a[DropDirection.UP] = 'Top',
    _a[DropDirection.DOWN] = 'Bottom',
    _a);
var fadeIn = keyframes(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  from {\n    transform: translateX(-5px);\n    opacity: 0;\n  }\n\n  to {\n    transform: translateX(0px);\n    opacity: 1;\n  }\n"], ["\n  from {\n    transform: translateX(-5px);\n    opacity: 0;\n  }\n\n  to {\n    transform: translateX(0px);\n    opacity: 1;\n  }\n"])));
var fadeInAnimation = css(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  animation: ", " 0.3s ease;\n"], ["\n  animation: ", " 0.3s ease;\n"])), fadeIn);
var showMenu = keyframes(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  from {\n    transform: scaleY(0);\n    opacity: 0;\n  }\n\n  to {\n    transform: scaleY(1);\n    opacity: 1;\n  }\n"], ["\n  from {\n    transform: scaleY(0);\n    opacity: 0;\n  }\n\n  to {\n    transform: scaleY(1);\n    opacity: 1;\n  }\n"])));
var hideMenu = keyframes(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\nfrom {\n    transform: scaleY(1);\n    opacity: 1;\n  }\n\n  to {\n    transform: scaleY(0);\n    opacity: 0;\n  }\n"], ["\nfrom {\n    transform: scaleY(1);\n    opacity: 1;\n  }\n\n  to {\n    transform: scaleY(0);\n    opacity: 0;\n  }\n"])));
var showMenuAnimation = function (direction, closeAnimate) { return css(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  animation: ", " 0.2s ease;\n  animation-fill-mode: forwards;\n  transform-origin: ", ";\n"], ["\n  animation: ", " 0.2s ease;\n  animation-fill-mode: forwards;\n  transform-origin: ", ";\n"])), closeAnimate ? hideMenu : showMenu, direction === DropDirection.UP ? 'bottom' : 'top'); };
export var TinyDropMenuWrapper = styled.div.withConfig({ displayName: "TinyDropMenuWrapper", componentId: "sc-1bigxx5" })({
    width: 35,
    borderRadius: 17,
    display: 'inline-block',
    position: 'relative',
});
export var DropMenuButton = styled.button.withConfig({ displayName: "DropMenuButton", componentId: "sc-flujd5" })(function (_a) {
    var theme = _a.theme, color = _a.color;
    return ({
        width: 35,
        height: 35,
        border: 'none',
        boxShadow: 'none',
        outline: 'none',
        padding: 0,
        margin: 0,
        backgroundColor: theme.colors[color].default,
        cursor: 'pointer',
        transition: '0.3s',
        transitionProperty: 'background-color, border-radius',
        transitionTimingFunction: 'ease',
        '&:hover': {
            backgroundColor: theme.colors[color].hover,
        },
        '&:disabled': {
            backgroundColor: theme.colors[color].disabled,
            cursor: 'not-allowed',
        },
    });
});
export var DropMenuOpenButton = styled(DropMenuButton).withConfig({ displayName: "DropMenuOpenButton", componentId: "sc-lvuzor" })({
    display: 'flex',
    borderRadius: 17,
    justifyContent: 'center',
    alignItems: 'center',
}, function (_a) {
    var _b;
    var open = _a.open, dropDirection = _a.dropDirection;
    return open
        ? (_b = {},
            _b["border" + dropDirectionMap[dropDirection] + "LeftRadius"] = 0,
            _b["border" + dropDirectionMap[dropDirection] + "RightRadius"] = 0,
            _b) : null;
});
export var DropMenuItemTitle = styled.div.withConfig({ displayName: "DropMenuItemTitle", componentId: "sc-1cvbrom" })(function (_a) {
    var color = _a.color, theme = _a.theme;
    return ({
        position: 'absolute',
        backgroundColor: theme.colors[color].default,
        height: 35,
        fontSize: 14,
        left: '100%',
        top: 0,
        display: 'none',
        alignItems: 'center',
        paddingRight: 17,
        borderTopRightRadius: 17,
        borderBottomRightRadius: 17,
        color: '#fff',
        whiteSpace: 'nowrap',
    });
});
export var DropMenuItemButton = styled(DropMenuButton).withConfig({ displayName: "DropMenuItemButton", componentId: "sc-14x93kj" })(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  position: relative;\n  ", "\n  &:hover {\n    border-top-right-radius: 0;\n    border-bottom-right-radius: 0;\n    ", " {\n      display: flex;\n      background-color: ", ";\n      ", "\n    }\n  }\n  &:disabled {\n    ", " {\n      background-color: ", ";\n    }\n  }\n"], ["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  position: relative;\n  ",
    "\n  &:hover {\n    border-top-right-radius: 0;\n    border-bottom-right-radius: 0;\n    ", " {\n      display: flex;\n      background-color: ", ";\n      ", "\n    }\n  }\n  &:disabled {\n    ", " {\n      background-color: ", ";\n    }\n  }\n"])), function (_a) {
    var _b;
    var dropDirection = _a.dropDirection;
    return ({
        '&:last-child': (_b = {},
            _b["border-" + dropDirectionMap[dropDirection].toLocaleLowerCase() + "-right-radius"] = 17,
            _b["border-" + dropDirectionMap[dropDirection].toLocaleLowerCase() + "-left-radius"] = 17,
            _b),
    });
}, DropMenuItemTitle, function (_a) {
    var theme = _a.theme, color = _a.color;
    return theme.colors[color].hover;
}, fadeInAnimation, DropMenuItemTitle, function (_a) {
    var theme = _a.theme, color = _a.color;
    return theme.colors[color].disabled;
});
export var DropMenuList = styled.div.withConfig({ displayName: "DropMenuList", componentId: "sc-1akxb0v" })(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  position: absolute;\n  display: flex;\n  ", "\n  ", ";\n"], ["\n  position: absolute;\n  display: flex;\n  ",
    "\n  ",
    ";\n"])), function (_a) {
    var dropDirection = _a.dropDirection, closeAnimate = _a.closeAnimate;
    return showMenuAnimation(dropDirection, closeAnimate);
}, function (_a) {
    var dropDirection = _a.dropDirection;
    return dropDirection === DropDirection.DOWN
        ? { top: '100%', flexDirection: 'column' }
        : { bottom: '100%', flexDirection: 'column-reverse' };
});
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7;
