var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useCallback, useEffect, useState, useRef } from 'react';
import styled from 'styled-components';
import defaultTheme from "../../../theme";
import { Search as SearchIcon, Times as TimesIcon } from "../../icons";
import { StyledInput } from './StyledInput';
var Wrapper = styled.div.withConfig({ displayName: "Wrapper", componentId: "sc-xbt7e6" })(function (_a) {
    var _b;
    var theme = _a.theme, active = _a.active;
    return (_b = {
            position: 'relative',
            display: 'inline-block',
            '& svg': {
                cursor: 'pointer',
                fill: theme.colors.primary[active ? 'dark' : 'light'],
                width: '1em',
                position: 'absolute',
                transform: 'translate(-1.5em, 5px) scale(0.7)',
            },
            '&:focus svg, &:focus:hover svg, &:hover svg': {
                fill: theme.colors.primary.dark,
            }
        },
        _b[StyledInput] = {
            paddingRight: '2.2em',
        },
        _b);
}, function (_a) {
    var _b;
    var open = _a.open;
    return open
        ? (_b = {},
            _b[StyledInput] = {
                borderBottomLeftRadius: 0,
                borderBottomRightRadius: 0,
            },
            _b) : null;
}, function (_a) {
    var fluid = _a.fluid;
    return (fluid ? { width: '100%' } : null);
});
Wrapper.defaultProps = {
    theme: defaultTheme,
};
var Results = styled.div.withConfig({ displayName: "Results", componentId: "sc-1bbe9xr" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: absolute;\n  top: 2em;\n  left: 0;\n  right: 0;\n  z-index: 100;\n\n  background-color: white;\n  border-bottom-left-radius: ", ";\n  border-bottom-right-radius: ", ";\n  border: 1px solid ", ";\n  max-height: 16em;\n  overflow-x: hidden;\n  overflow-y: auto;\n  box-sizing: border-box;\n"], ["\n  position: absolute;\n  top: 2em;\n  left: 0;\n  right: 0;\n  z-index: 100;\n\n  background-color: white;\n  border-bottom-left-radius: ", ";\n  border-bottom-right-radius: ", ";\n  border: 1px solid ", ";\n  max-height: 16em;\n  overflow-x: hidden;\n  overflow-y: auto;\n  box-sizing: border-box;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadius;
}, function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadius;
}, function (_a) {
    var theme = _a.theme;
    return theme.colors.primary.default;
});
Results.defaultProps = {
    theme: defaultTheme,
};
export var Search = function (_a) {
    var onClear = _a.onClear, children = _a.children, className = _a.className, rest = __rest(_a, ["onClear", "children", "className"]);
    var ref = useRef(null);
    var Icon = rest.value ? TimesIcon : SearchIcon;
    var _b = useState(false), isOpen = _b[0], setOpen = _b[1];
    // Re-open or close
    var handleClick = useCallback(function (e) {
        // @ts-ignore
        if (ref && ref.current && ref.current.contains(e.target)) {
            setOpen(true);
            return;
        }
        setOpen(false);
    }, []);
    useEffect(function () {
        document.addEventListener('mousedown', handleClick, false);
        return function () { return document.removeEventListener('mousedown', handleClick, false); };
    }, [handleClick]);
    var showResults = isOpen && !!children;
    return (React.createElement(Wrapper, { active: !!rest.value, open: showResults, fluid: rest.fluid, ref: ref, className: className },
        React.createElement(StyledInput, __assign({}, rest)),
        React.createElement(Icon, { onClick: onClear }),
        showResults && React.createElement(Results, null, children)));
};
var templateObject_1;
